/*
 * Experiment 5: Temperature Controlled DC Motor
 * Find all the details about this experiment in the book << The Logic of things >>
 * Created 23 March 2017
 * By Zeroplus Technology Co. Ltd
 */
const int motorPin = 9, temperaturePin = 0;
int degreesC = 0, temperature = 0;
const long timeInterval = 1000;
long startTime = 0, currentTime = 0;

void setup() {
  pinMode(motorPin, OUTPUT);
  Serial.begin(9600);
  unsigned long currentMillis = millis();
}

void loop() {
  unsigned long currentMillis = millis();
  if(currentMillis - startTime >= timeInterval) {
    temperature = getTemperature_lm335(temperaturePin);
    Serial.print(temperature);
    Serial.print("\n");
    startTime = currentMillis;
  }
  if(temperature >= 29) {
    motorOn();
  }
  else {
    motorOff();
    }
}
void motorOn() { 
  analogWrite(motorPin, 160);  // turn the motor On
}
void motorOff() {
  analogWrite(motorPin, 0); // turn the motor Off
  }
float getTemperature_lm335(int pin) { 
  float voltage = 0;
  float kelvin = 0;
  float read_voltage = analogRead(pin);
  float millivolts = (read_voltage/1024.0) * 5000;
  kelvin = (millivolts/10);
  degreesC = (kelvin - 273);
  return (degreesC);
}

